/* *********************************************************************** *
 * project: org.matsim.*												   *
 *                                                                         *
 * *********************************************************************** *
 *                                                                         *
 * copyright       : (C) 2018 by the members listed in the COPYING,        *
 *                   LICENSE and WARRANTY file.                            *
 * email           : info at matsim dot org                                *
 *                                                                         *
 * *********************************************************************** *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *   See also COPYING, LICENSE and WARRANTY file                           *
 *                                                                         *
 * *********************************************************************** */
package org.matsim.codeexamples.config.external;

import java.io.File;
import org.junit.Test;
import org.matsim.core.utils.io.IOUtils;
import org.matsim.core.utils.io.UncheckedIOException;
import org.matsim.roadpricing.RunRoadPricingExample;

/**
 * @author vsp-gleich
 *
 */
public class ExternalMobsimByConfigfileTest {
	
	/**
	 * Test method for {@link RunExternalMobsimExample#main(java.lang.String[])}.
	 */
	@SuppressWarnings("static-method")
	@Test
	public final void testMain() {
		try {
			IOUtils.deleteDirectoryRecursively(new File("./output/example").toPath());
		} catch ( UncheckedIOException ee ) {
			// (normally, the directory should NOT be there initially.  It might, however, be there if someone ran the main class in some other way,
			// and did not remove the directory afterwards.)
		}
		RunExternalMobsimExample.main(new String[]{"examples/tutorial/config/externalMobsim.xml"});
		IOUtils.deleteDirectoryRecursively(new File("./output/example").toPath());
		// (here, the directory should be there)
	}

}
